import java.awt.*;
import java.awt.event.*;

class ScrollingPictureWindow 
  extends Panel 
  implements AdjustmentListener{
  ImageCanvas imageCanvas ;
  Scrollbar vertBar ;
  Scrollbar horzBar ;
  Image image ;
  Canvas canvas;

  Choice cb;
  Button b;

  int imgWidth ;
  int imgHeight ;
  int imgX ;
  int imgY ;
  int block ;

  public ScrollingPictureWindow ( Image img ) {
    image = img ;
    imgX = 0 ;
    imgY = 0 ;

    while ((imgHeight = image.getHeight(this)) == -1 ) {
      // loop until image loaded
    }
    while ((imgWidth = image.getWidth(this)) == -1 ) {
      // loop until image loaded
    }

    imageCanvas = new ImageCanvas( image ) ;
    canvas      = new Canvas();
    canvas.setSize(10,10);

    vertBar = new Scrollbar( Scrollbar.VERTICAL ) ;
    horzBar = new Scrollbar( Scrollbar.HORIZONTAL ) ;

    cb = new Choice();
    cb.add("Linden");
    cb.add("Birth");

    b = new Button("Button 1");   

    GridBagLayout gridbag = new GridBagLayout();

    setLayout( gridbag ) ;

    {
      GridBagConstraints c = new GridBagConstraints();
      c.fill = GridBagConstraints.BOTH ;
      c.weightx = 1.0;
      c.weighty = 1.0;
      gridbag.setConstraints(imageCanvas, c);
      add( imageCanvas ) ;
    }

    {
      GridBagConstraints c = new GridBagConstraints();
      c.fill = GridBagConstraints.VERTICAL ;
      c.gridwidth = GridBagConstraints.REMAINDER ;
      gridbag.setConstraints(vertBar, c);
      add( vertBar ) ;
    }

    {
      GridBagConstraints c = new GridBagConstraints();
      c.fill = GridBagConstraints.HORIZONTAL ;
      c.gridwidth = 1; //GridBagConstraints.REMAINDER ;
      gridbag.setConstraints(horzBar, c);
      add( horzBar ) ;
    }
    /*
    {
      GridBagConstraints c = new GridBagConstraints();
      c.fill = GridBagConstraints.HORIZONTAL ;
      c.gridwidth = GridBagConstraints.REMAINDER ;
      gridbag.setConstraints(canvas, c);
      add( canvas ) ;
    }    

    {
      GridBagConstraints c = new GridBagConstraints();
      c.fill = GridBagConstraints.HORIZONTAL ;
      c.gridwidth = 1; //GridBagConstraints.RELATIVE ;
      gridbag.setConstraints(cb, c);
      add( cb ) ;
    }    
    {
      GridBagConstraints c = new GridBagConstraints();
      c.fill = GridBagConstraints.HORIZONTAL ;
      c.gridwidth = GridBagConstraints.REMAINDER ;
      gridbag.setConstraints(canvas, c);
      add( canvas ) ;
    }
    

    {
      GridBagConstraints c = new GridBagConstraints();
      c.fill = GridBagConstraints.HORIZONTAL ;
      c.gridwidth = GridBagConstraints.REMAINDER ;
      gridbag.setConstraints(b, c);
      add( b ) ;
    }
    */
    vertBar.addAdjustmentListener( this ) ;
    horzBar.addAdjustmentListener( this ) ;
  }

  public synchronized void setBounds( int x,
                                      int y,
                                      int width,
                                      int height) {
    super.setBounds( x, y, width, height ) ;
    if ( width > imgWidth + vertBar.getBounds().width ) {
      horzBar.setEnabled( false ) ;
    } else {
      horzBar.setEnabled( true ) ;
      Rectangle bndRect = getBounds() ;
      int barWidth = vertBar.getPreferredSize().width ;
      int max = imgWidth - (bndRect.width - barWidth);
      block = max/10 ;
      int oldMax = horzBar.getMaximum() ;
      if ( oldMax == 0) {
        imgX = 0 ;
      } else {
        imgX = (int)(((float)imgX/(float)oldMax) *
                     (float)max) ;
      }
      horzBar.setValues( imgX, block, 0, max ) ;
      horzBar.setBlockIncrement( block ) ;
    }
    if (height > imgHeight + horzBar.getBounds().height) {
      vertBar.setEnabled( false ) ;
    } else {
      vertBar.setEnabled( true ) ;
      Rectangle bndRect = getBounds() ;
      int barHeight = horzBar.getPreferredSize().height ;
      int max = imgHeight - (bndRect.height - barHeight) ;
      block = max/10 ;
      int oldMax = vertBar.getMaximum() ;
      if ( oldMax == 0) {
        imgY = 0 ;
      } else {
        imgY = (int)(((float)imgY/(float)oldMax) *
                     (float)max) ;
      }
      vertBar.setValues( imgY, block, 0, max ) ;
      vertBar.setBlockIncrement( block ) ;
    }
  }

  public void adjustmentValueChanged(AdjustmentEvent e) {
    imgY = vertBar.getValue() ;
    imgX = horzBar.getValue() ;
    imageCanvas.repaint();
  }
};


class ImageCanvas extends Canvas {
  Image canvasImg ;
  public ImageCanvas( Image img ) {
    canvasImg = img ;
  }
  public void paint(Graphics g) {
    if ( getParent().isEnabled() ) {
      g.drawImage( canvasImg,
                   -1 * ((ScrollingPictureWindow)getParent()).imgX,
                   -1 * ((ScrollingPictureWindow)getParent()).imgY,
                   this ) ;
    }
  }
};
